         subroutine calc_cons(rho, v, P, tau, S, Gamma)

c------------------------------------------------------------
c Sun Jun 29 18:24:58 PDT 2003
c
c It calculates the primitive variables rho, v and P 
c from the conservative one tau and S
c
c------------------------------------------------------------

         implicit      none

         character*10   cdnm
         parameter   ( cdnm = 'calc_cons' ) 

         logical       ltrace
         parameter   ( ltrace = .false. )

         real*8       tau,    S
         real*8       rho,    v,  P
         real*8       Gamma
         real*8       W
c============================================================
c============================================================
         if ( ltrace ) then
            write(0,*) cdnm,':   rho = ', rho
            write(0,*) cdnm,':     v = ', v
            write(0,*) cdnm,': Gamma = ', Gamma
         endif
         W = 1.0d0/sqrt( 1.0d0 - v**2 )
         P = (Gamma - 1.0d0) * rho
         tau = (rho + P) * W**2 - P
         S   = v * (tau + P)
         return
         end

