c------------------------------------------------------------
c Sun Jun 29 14:51:01 PDT 2003
c------------------------------------------------------------

c------------------------------------------------------------
c   Set the initial values for rho, v, P, tau and S
c------------------------------------------------------------

         character*11  cdnm
         parameter   ( cdnm = 'init_ultra' ) 

         logical       ltrace
         parameter   ( ltrace = .true. )

         real*8      cpi
         parameter ( cpi = 3.141 5926 5358 9793 d0 )

         integer     Nx

         integer     j,  jmid

         real*8      W

c============================================================
         include       'fcn_rw.inc'

         logical       newton_trace
         parameter   ( newton_trace = .false. )

         logical       soda_trace
         parameter   ( soda_trace = .false. )

         real*8        tol
         parameter   ( tol = 1.0d-13 )

         real*8        soda_tol
         parameter   ( soda_tol = 1.0d-10 )

         integer       maxiter
         parameter   ( maxiter = 100 )

         real*8        norm_res

         real*8        res1,  res2
         real*8        j11, j12,  j21,  j22

         real*8        c
         real*8        drhoM,   dvM
         real*8        t0

         integer       citer

c----------------------------------------------------------------

c        real*8        ximin,   ximax
         real*8        xibgn,   xiend,  xicurr
c        real*8        dxi

         integer       Nxi

         real*8        lambda1,   lambda2  

c----------------------------------------------------------------
        
         integer        neq
         parameter    ( neq = 2 )

         real*8         y(neq),     yprime(neq)
         integer        itol
         real*8         rtol,    atol
         integer        itask,   istate,     iopt

         integer        lrw
         parameter    ( lrw = 22 + neq * 16 )

         real*8         rwork(lrw)

         integer        liw
         parameter    ( liw = 20 + neq )

         integer        iwork(liw)
         integer        jt

         external       fcn_rw1,   fcn_rw2,  jac

c----------------------------------------------------------------

         real*8         shock_speed1, shock_speed2
         real*8         x_shock1,     x_shock2

         real*8         dx  

         integer        ret,   gft_out_brief
         real*8         bbox(2)
         integer        shape(1)

         real*8         i,  i_prev,   ic
         real*8         xi_x
c============================================================
         Nx    = g1_Nx
         Nxi   = g1_Nx
         rhoL  = rho_L
         rhoR  = rho_R
         vL    = v_L    
         vR    = v_R

c-----------------------------------------------------------------------
c        Use a more convenient variable for the number of spatial
c        grid points.
c-----------------------------------------------------------------------

         Nx  = g1_nx
         Nxi = g1_nx
         if ( ltrace ) then
            write(0,*) cdnm,':           Nx =', Nx
            write(0,*) cdnm,':       rho_xc =', rho_xc
            write(0,*) cdnm,':        rho_R =', rho_R
            write(0,*) cdnm,':        rho_L =', rho_L
            write(0,*) cdnm,':         v_xc =', v_xc
            write(0,*) cdnm,':          v_R =', v_R
            write(0,*) cdnm,':          v_L =', v_L
            write(0,*) cdnm,':        Gamma =', Gamma
         endif
         if ( rho_xc .ne. v_xc ) then
            write(0,*) cdnm,': rho_xc <> v_xc'
            write(0,*) cdnm,': More that one Riemann problem'
            write(0,*) cdnm,': Stopping'
            write(0,*) cdnm,': (to solve the problem Use rho_xc=v_xc)'
            stop
         endif
         if ( rho_L .lt. rho_R ) then
            write(0,*) cdnm,': this solver is not able'  
            write(0,*) cdnm,': to handle rho_L < rho_R'
            write(0,*) cdnm,': Stopping'
            write(0,*) cdnm,': (to solve the problem '//
     &                      'Reflect the system)'
            stop
         endif
         if ( xmin .ne. -1.0d0 .or. xmax .ne. 1.0d0 ) then
            write(0,*) cdnm,': BAD RANGE' 
            write(0,*) cdnm,': xmin=',xmin
            write(0,*) cdnm,': xmax=',xmax
            write(0,*) cdnm,': it can ONLY do xmin=-1.0'
            write(0,*) cdnm,': and            xmax=-1.0'
            write(0,*) cdnm,' Stopping'
            stop
         endif
         j = 1
         do while ( x(j) .lt. rho_xc )  
            rho_n(j) = rho_L
            j = j + 1
         enddo  
         jmid = j     
         do j = jmid, Nx
            rho_n(j) = rho_R
         enddo
         j = 1
         do while ( x(j) .lt. v_xc )  
            v_n(j) = v_L
            j = j + 1
         enddo  
         jmid = j     
         do j = jmid, Nx
            v_n(j) = v_R
         enddo
         do j = 1, Nx  
            W = 1.0d0/sqrt(1.0d0-v_n(j)**2) 
            P_n(j)   = (Gamma-1.0d0) * rho_n(j) 
            tau_n(j) = (rho_n(j)+P_n(j)) * W**2 - P_n(j)
            S_n(j)   = v_n(j) * (tau_n(j) + P_n(j))
         enddo

c------------------------------------------------------------------------------
c------------------------------------------------------------------------------
c------------------------------------------------------------------------------
c------------------------------------------------------------------------------
c------------------------------------------------------------------------------
c============================================================
c============================================================
         Nx    = g1_Nx  
         rhoL  = rho_L
         rhoR  = rho_R
         vL    = v_L
         vR    = v_R
         c = sqrt(Gamma-1.0d0)
         if ( ltrace ) then
            write(0,*) cdnm, '###############################'
            write(0,*) cdnm, ': Solving Riemann problem   '
            write(0,*) cdnm, ': for the ultrarelativistic '
            write(0,*) cdnm, ': equation for the following'
            write(0,*) cdnm, ': parameters:'
            write(0,*) cdnm, ':   Gamma =', Gamma
            write(0,*) cdnm, ':    rhoL =', rhoL
            write(0,*) cdnm, ':      vL =', vL
            write(0,*) cdnm, ':    rhoR =', rhoR
            write(0,*) cdnm, ':      vR =', vR
            write(0,*) cdnm, '-------------------------------'
            write(0,*) cdnm, ':       c =', c
            write(0,*) cdnm, ':     tol =', tol
            write(0,*) cdnm, ': maxiter =', maxiter
            write(0,*) cdnm, '###############################'
         endif 
         if ( Gamma .gt. 2.0d0 .or. Gamma .lt. 1.0d0) then
             write(0,*) cdnm, ' Gamma shold be in the rage:'
             write(0,*) cdnm, ' 2>Gamma>1'
             stop
         endif
         if ( rhoL .lt. 0.0d0 .or. rhoR .lt. 0.0d0 ) then
             write(0,*) cdnm,' It shold be in the rage:'
             write(0,*) cdnm,' rhoL and rhoR > 0'
             stop
         endif
         if ( abs(vL) .gt. 1.0d0 .or. abs(vR) .gt. 1.0d0 ) then
             write(0,*) cdnm,' It shold be in the rage:'
             write(0,*) cdnm,' abs(vL) and abs(vR) < 1'
             stop
         endif
         norm_res = tol + 1.0d0
         citer = 0
         rhoM = 0.2830076958d0
         rhoM = rhoL
         vM   = 0.6014273495d0
         vM   = vL
         if ( newton_trace ) then
               write(0,*) cdnm,':  Guesses: '
               write(0,*) cdnm,':   rhoM =',rhoM
               write(0,*) cdnm,':     vM =',vM
               write(0,*) cdnm,'::::::::::::::::::::::::::'
         endif 
         do while ( norm_res .gt. tol .and. citer .lt. maxiter )
            citer = citer + 1 
      t0 = (1.D0+vL)/(1.D0-vL)*rhoL**(2.D0*sqrt(Gamma-1.D0)/Gamma)-(1.D0
     #+vM)/(1.D0-vM)*rhoM**(2.D0*sqrt(Gamma-1.D0)/Gamma)
            res1 = t0
      t0 = Gamma**2*(rhoM*vM/(1.D0-vM**2)-rhoR*vR/(1.D0-vR**2))**2.D0-((
     #c**2+vM**2)/(1.D0-vM**2)*rhoM-(c**2+vR**2)/(1.D0-vR**2)*rhoR)*((c*
     #*2*vM**2+1.D0)/(1.D0-vM**2)*rhoM-(c**2*vR**2+1.D0)/(1.D0-vR**2)*rh
     #oR)
            res2 = t0
      t0 = -2.D0*(1.D0+vM)/(1.D0-vM)*rhoM**(2.D0*sqrt(Gamma-1.D0)/Gamma)
     #*sqrt(Gamma-1.D0)/Gamma/rhoM
            j11  = t0
      t0 = -1.D0/(1.D0-vM)*rhoM**(2.D0*sqrt(Gamma-1.D0)/Gamma)-(1.D0+vM)
     #/(1.D0-vM)**2.D0*rhoM**(2.D0*sqrt(Gamma-1.D0)/Gamma)
            j12  = t0
      t0 = 2.D0*Gamma**2*(rhoM*vM/(1.D0-vM**2)-rhoR*vR/(1.D0-vR**2))*vM/
     #(1.D0-vM**2)-(c**2+vM**2)/(1.D0-vM**2)*((c**2*vM**2+1.D0)/(1.D0-vM
     #**2)*rhoM-(c**2*vR**2+1.D0)/(1.D0-vR**2)*rhoR)-((c**2+vM**2)/(1.D0
     #-vM**2)*rhoM-(c**2+vR**2)/(1.D0-vR**2)*rhoR)*(c**2*vM**2+1.D0)/(1.
     #D0-vM**2)
           j21  = t0
      t0 = 2.D0*Gamma**2*(rhoM*vM/(1.D0-vM**2)-rhoR*vR/(1.D0-vR**2))*(rh
     #oM/(1.D0-vM**2)+2.D0*rhoM*vM**2/(1.D0-vM**2)**2.D0)-(2.D0*rhoM*vM/
     #(1.D0-vM**2)+2.D0*(c**2+vM**2)/(1.D0-vM**2)**2.D0*rhoM*vM)*((c**2*
     #vM**2+1.D0)/(1.D0-vM**2)*rhoM-(c**2*vR**2+1.D0)/(1.D0-vR**2)*rhoR)
     #-((c**2+vM**2)/(1.D0-vM**2)*rhoM-(c**2+vR**2)/(1.D0-vR**2)*rhoR)*(
     #2.D0*c**2*vM/(1.D0-vM**2)*rhoM+2.D0*(c**2*vM**2+1.D0)/(1.D0-vM**2)
     #**2.D0*rhoM*vM)
            j22  = t0

            drhoM =  (-j22 * res1 + j12 * res2) /  
     &               (j22*j11-j12*j21)
            
            dvM   =  (-j21 * res1 + j11 * res2) /
     &               (j21*j12-j11*j22)

            rhoM = rhoM + drhoM 
            vM   = vM   + dvM 

            norm_res = 0.5d0*(abs(drhoM)+abs(dvM))
            if ( newton_trace ) then
               write(0,*) cdnm,':     citer =',citer     
               write(0,*) cdnm,':     res1 =',res1     
               write(0,*) cdnm,':     res2 =',res2     
               write(0,*) cdnm,':      j11 =',j11
               write(0,*) cdnm,':      j12 =',j12
               write(0,*) cdnm,':      j21 =',j21
               write(0,*) cdnm,':      j22 =',j22
               write(0,*) cdnm,':    drhoM =',drhoM
               write(0,*) cdnm,':      dvM =',dvM
               write(0,*) cdnm,':     rhoM =',rhoM
               write(0,*) cdnm,':       vM =',vM
               write(0,*) cdnm,': norm_res =',norm_res
               write(0,*) cdnm,'::::::::::::::::::::::::::'
            endif
            if ( abs(vM) .gt. 1.0d0 ) then
               write(0,*) cdnm,':    Superluminal speed for vM'
               stop
            endif
            if ( rhoM .lt. 0.0d0 ) then
               write(0,*) cdnm,':    Negative value for rhoM'
               stop
            endif
         enddo
         if (citer .ge. maxiter ) then
               write(0,*) cdnm,':    Newton solver did not converge'
               write(0,*) cdnm,':    in', citer, ' iterations.'
         endif
         if ( ltrace ) then
              write(0,*) cdnm,' rhoM =',rhoM
              write(0,*) cdnm,'   vM =',vM
         endif
c--------------------------------------------------------------------
c    Solution of the Rarefaction waves.
c--------------------------------------------------------------------

         call calc_cons(rhoL, vL, PL, tauL, SL, Gamma)
         call calc_cons(rhoM, vM, PM, tauM, SM, Gamma)
         call calc_cons(rhoR, vR, PR, tauR, SR, Gamma)

c--------------------------------------------------------------------
c    Solution of the 1-wave.
c--------------------------------------------------------------------

         y(1)   = tauL
         y(2)   = SL 
         ximin  = lambda1 (tauL, SL, rhoL, vL, PL, Gamma) 
         ximax  = lambda1 (tauM, SM, rhoM, vM, PM, Gamma) 
         dxi    = (ximax - ximin) / (Nxi-1.0d0)
         xicurr = ximin
         tau1(1) = y(1)
         S1(1)   = y(2)
         Gamma1 = Gamma
         itol   = 1   
         rtol   = soda_tol 
         atol   = soda_tol
         itask = 1
         iopt  = 0
         jt    = 2
         if ( soda_trace ) then
            write(0,*) cdnm,'::::::::::::::::::::::::::'
            write(0,*) cdnm,'::: solving rare. wave :::'
            write(0,*) cdnm,'::::::::::::::::::::::::::'
            write(0,*) cdnm,': Nxi =',Nxi
            write(0,*) cdnm,': dxi =',dxi
            write(0,*) cdnm,': y(1)  =',y(1)
            write(0,*) cdnm,': y(2)  =',y(2)
            write(0,*) cdnm,': ximin =',ximin
            write(0,*) cdnm,': ximax =',ximax
            write(0,*) cdnm,'::::::::::::::::::::::::::'
            write(0,*) cdnm,'::::::::::::::::::::::::::'
            write(0,*) cdnm,'    xi =',xicurr
            write(0,*) cdnm,': y(1) =',y(1)
            write(0,*) cdnm,': y(2) =',y(2)
         endif
         do j = 2, Nxi
               xibgn  = xicurr
               xiend  = xicurr + dxi
               xicurr = xiend
               istate = 1
               call lsoda(fcn_rw1, neq, y, xibgn, xiend,
     &                    itol, rtol, atol, itask,
     &                    istate, iopt,rwork,lrw,iwork,liw,jac,jt)
               tau1(j) = y(1) 
               S1(j)   = y(2)
               if ( soda_trace ) then
                  write(0,*) cdnm,'::::::::::::::::::::::::::'
                  write(0,*) cdnm,':  xi  =', xicurr+dxi
                  write(0,*) cdnm,': y(1) =', y(1)
                  write(0,*) cdnm,': y(2) =', y(2)
                  write(0,*) cdnm,': istate =', istate
               endif
         enddo
c--------------------------------------------------------------------
c    Solution of the 2-wave.
c--------------------------------------------------------------------

         y(1)   = tauL
         y(2)   = SL 
         ximin  = lambda2 (tauL, SL, rhoL, vL, PL, Gamma) 
         ximax  = lambda2 (tauM, SM, rhoM, vM, PM, Gamma) 
         dxi    = (ximax - ximin) / (Nxi-1.0d0)
         xicurr = ximin
         tau2(1) = y(1)
         S2(1)   = y(2)
         Gamma1 = Gamma
         itol   = 1   
         rtol   = soda_tol 
         atol   = soda_tol
         itask = 1
         iopt  = 0
         jt    = 2
         if ( soda_trace ) then
            write(0,*) cdnm,'::::::::::::::::::::::::::'
            write(0,*) cdnm,'::: solving rare. wave :::'
            write(0,*) cdnm,'::::::::::::::::::::::::::'
            write(0,*) cdnm,': Nxi =',Nxi
            write(0,*) cdnm,': dxi =',dxi
            write(0,*) cdnm,': y(1)  =',y(1)
            write(0,*) cdnm,': y(2)  =',y(2)
            write(0,*) cdnm,': ximin =',ximin
            write(0,*) cdnm,': ximax =',ximax
            write(0,*) cdnm,'::::::::::::::::::::::::::'
            write(0,*) cdnm,'::::::::::::::::::::::::::'
            write(0,*) cdnm,'    xi =',xicurr
            write(0,*) cdnm,': y(1) =',y(1)
            write(0,*) cdnm,': y(2) =',y(2)
         endif
         xi(1) = xicurr
         do j = 2, Nxi
               xibgn  = xicurr
               xiend  = xicurr + dxi
               xicurr = xiend
               xi(j)  = xicurr
               istate = 1
               call lsoda(fcn_rw2, neq, y, xibgn, xiend,
     &                    itol, rtol, atol, itask,
     &                    istate, iopt,rwork,lrw,iwork,liw,jac,jt)
               tau2(j) = y(1) 
               S2  (j) = y(2)
               if ( soda_trace ) then
                  write(0,*) cdnm,'::::::::::::::::::::::::::'
                  write(0,*) cdnm,':  xi  =', xicurr+dxi
                  write(0,*) cdnm,': y(1) =', y(1)
                  write(0,*) cdnm,': y(2) =', y(2)
                  write(0,*) cdnm,': istate =', istate
               endif
         enddo
         return
